-- "TRADE_CLOSED"
-- "TRADE_PLAYER_ITEM_CHANGED"
-- "TRADE_ACCEPT_UPDATE"
-- "TRADE_SHOW"
-- "TRADE_UPDATE"
CauldFrame = CreateFrame("Frame","CauldFrame",UIParent,"BasicFrameTemplate");

CauldButton={};
for i=1, 10 do
	CauldButton[i] = CauldFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	CauldButton[i]:SetHeight(10);
	CauldButton[i]:SetPoint("TOPLEFT", CauldFrame, "TOPLEFT", 10, -15-(17*i));
	CauldButton[i]:Hide();
	
	CauldButton[i+10] = CreateFrame("CheckButton", nil, CauldFrame, "InterfaceOptionsCheckButtonTemplate");
	CauldButton[i+10]:SetPoint("CENTER", CauldButton[i], "CENTER", 0, 0 );
	CauldButton[i+10]:SetPoint("RIGHT", CauldFrame, "RIGHT", 0, 0 );
	CauldButton[i+10]:SetScript("PostClick", function() Cauld_UpdateList(); end);
end

CauldList={};

function Cauld_Reminder()
local list="";
	for i=1, 10 do
		who=UnitName("Raid"..i);
		if(who~=nil and not CauldList[who]) then
			SendChatMessage("Don't forget to hand in a flask", "WHISPER", nil, who);
			list=list..", "..who;
		end
	end
	EDebug("These people still need to give me a flask: "..list:sub(3));
	SendChatMessage("These people still need to give me a flask: "..list:sub(3), "RAID");
end

local Flasks={"Flask of the Draconic Mind", "Flask of Steelskin", "Flask of the Winds", "Flask of Titanic Strength"};
function Cauld_CheckFlasks()
	for i=1, 7 do
		local itemName,_,quantity = GetTradeTargetItemInfo(i);
		for f=1,#Flasks do
			if(itemName==Flasks[f]) then 
				CauldList[CauldList.current]=true;
				for i=1, 10 do
					if(UnitName("Raid"..i)==CauldList.current) then
						CauldButton[i+10]:SetChecked(1)
						return;
					end
				end
			end
		end
	end
end

function Cauld_UpdateList()
	if(#CauldList>0 or ElgohSettings.Debug==1) then CauldFrame:Show(); end
	for i=1, 10 do
		local who=UnitName("Raid"..i);
		if(who~=nil) then
			CauldButton[i]:SetText(who);
			CauldButton[i]:Show();
			if(CauldButton[i+10]:GetChecked()) then CauldList[who]=true; else CauldList[who]=nil; end
			if(CauldList[who]) then CauldButton[i+10]:SetChecked(1); CauldButton[i]:SetTextColor(0.2,1,0.2); else CauldButton[i]:SetTextColor(1,0.2,0.2); end
		end
	end
	if(#CauldList==GetNumRaidMembers()) then 
		CauldFrameButton:SetText("Finish"); 
		CauldFrameButton:SetScript("OnClick", CauldFrame.Hide); 
	else
		CauldFrameButton:SetText("Remind"); 
		CauldFrameButton:SetScript("OnClick", Cauld_Reminder); 
	end
end

function Cauld_Event(self,event,...)
	if(event=="TRADE_CLOSED") then 
		Cauld_UpdateList(); 
	elseif(event=="TRADE_ACCEPT_UPDATE") then
		Cauld_CheckFlasks();
	elseif(event=="TRADE_SHOW") then
		CauldList.current=UnitName("NPC");
		EDebug(CauldList.current);
	else
		Cauld_UpdateList();
	end
end

function Cauld_Loaded()
	CauldFrame:SetScript("OnLoad", nil);
	
	CauldFrame:RegisterEvent("TRADE_CLOSED");
	CauldFrame:RegisterEvent("TRADE_ACCEPT_UPDATE");
	CauldFrame:RegisterEvent("TRADE_SHOW");
	CauldFrame:RegisterEvent("RAID_ROSTER_UPDATE");
	
	CauldFrame:SetScript("OnEvent", Cauld_Event);
	
	CauldFrame:SetWidth(150);
	CauldFrame:SetHeight(200);
	CauldFrameTitleText:SetText("Cauldronator");
	CauldFrame:SetPoint("CENTER", UIParent, "CENTER");
	Elgoh_AllowToMove(CauldFrame);
	CauldFrameButton = CreateFrame("Button","CauldFrameButton",CauldFrame,"UIPanelButtonTemplate")
	CauldFrameButton:SetPoint("BOTTOM", CauldFrame, "BOTTOM", 0,-10)
	CauldFrameButton:SetWidth(90);
	CauldFrameButton:SetHeight(22);
	CauldFrameButton:SetText("Reminder");
	CauldFrameButton:SetScript("OnClick", Cauld_Reminder);
	CauldFrame:Hide();	
end